﻿Imports System
Imports System.Drawing
Imports System.ComponentModel

Namespace System.Windows.Forms
   Public Class FormFinder
      'ruft den Delegaten auf, sobald Ctl auf einem Form aufsitzt. Wichtig, wenn Controls während
      '! ihrer Initialisierung auf das Form zugreifen müssen, auf dem sie aufsitzen (werden).

      Private WithEvents _ParentControl As Control
      Private _dlgFormFinder As Action(Of Form)

      Private Sub New(ByVal Ctl As Control, ByVal FormFoundAction As Action(Of Form))
         _dlgFormFinder = FormFoundAction
         'addhandler _ParentControl.ParentChanged,addressof Ctl_ParentChanged
         Ctl_ParentChanged(Ctl, EventArgs.Empty)
      End Sub

      Private Sub Ctl_ParentChanged(ByVal sender As Object, ByVal e As System.EventArgs) _
              Handles _ParentControl.ParentChanged
         Dim Ctl As Control = DirectCast(sender, Control)
         Do
            _ParentControl = Ctl
            Ctl = Ctl.Parent
         Loop Until Ctl Is Nothing
         If TypeOf _ParentControl Is Form Then
            _dlgFormFinder(DirectCast(_ParentControl, Form))
            _ParentControl = Nothing
         End If
      End Sub

      Public Shared Sub FindForm(ByVal Ctl As Control, ByVal FormFoundAction As Action(Of Form))
         Dim O As Object = New FormFinder(Ctl, FormFoundAction)
      End Sub

   End Class

End Namespace