﻿Imports System.Runtime.CompilerServices
Imports System.Drawing
Imports System.Runtime.InteropServices

Namespace System.Windows.Forms

   Public Module MiscX


#Region "WindowMessage"

      <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto, Size:=32)> _
      Public Structure SixteenShorts
         Public a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p As Short
         Public Overrides Function ToString() As String
            Return String.Concat("{", a, " ", b, ")(", c, " ", d, ") (", e, " ", f, ")(", g, " ", h, ") (", i, " ", j, ")(", k, " ", l, ") (", m, " ", n, ")(", o, " ", p, "}")
         End Function
      End Structure

      <Extension()> _
      Public Function LParamX(Of T As Structure)(ByVal msg As Message) As T
         Return DirectCast(msg.GetLParam(GetType(T)), T)
      End Function
      <Extension()> _
      Public Sub LParamX(ByVal msg As Message, ByVal value As Object)
         Marshal.StructureToPtr(value, msg.LParam, False)
      End Sub
#End Region 'WindowMessage

   End Module
   Public Class TypeCache(Of T)
      'eine Optimierung, die häufigen Aufruf von GetType(T) vermeidet. Aber kaum von Belang, denn GetType(T) ist sehr schnell (mit MyStopwatch an der Messbarkeitsgrenze)
      Public Shared ReadOnly Tp As Type = GetType(T)
   End Class
End Namespace
