﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace System
   ''' <summary>
   ''' kind of "endless collection": when reaching the end it starts new
   ''' </summary>
   Public Class DataCircle(Of T)
      Implements IDisposable

      Private _Enumerable As IEnumerable(Of T)
      Private _Enrt As IEnumerator(Of T)

      Public Sub New(ByVal Enumerable As IEnumerable(Of T))
         _Enumerable = Enumerable
         _Enrt = _Enumerable.GetEnumerator()
      End Sub

      Public Sub New(ByVal First As T, ByVal ParamArray Furthers As T())
         Me.New((New T() {First}).Union(Furthers))
      End Sub

      Public Function GetNext() As T
         If _Enrt.MoveNext() Then Return _Enrt.Current
         _Enrt.Dispose()
         _Enrt = _Enumerable.GetEnumerator()
         If _Enrt.MoveNext() Then Return _Enrt.Current
         Throw New Exception("Die dem DataCircle zugrunde liegende Auflistung ist leer!")
      End Function

      Protected Overridable Sub Dispose(ByVal disposing As Boolean)
         If Not disposing OrElse _Enrt Is Nothing Then Return
         _Enrt.Dispose()
         _Enrt = Nothing
      End Sub

      Public Sub Dispose() Implements IDisposable.Dispose
         Dispose(True)
         GC.SuppressFinalize(Me)
      End Sub
   End Class
End Namespace
